package cl.mc3d;

import com.keypoint.PngEncoder;

import com.keypoint.PngEncoderB;

import java.awt.AWTException;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Robot;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;

import java.io.*;

import java.net.ConnectException;
import java.net.URL;

import java.net.URLConnection;

import java.util.Iterator;

import javax.imageio.IIOImage;
import javax.imageio.ImageIO;

import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import sun.misc.BASE64Encoder;
class ScreenCapture
  extends JFrame
  implements Runnable
{
  Thread Hilo=null;
boolean capture=false;
  BufferedImage screencapture=null;
String Id=null;
String Servidor=null;
  public ScreenCapture()
  {
    setTitle("Web conference");
    Servidor=""+System.getProperty("servidor");
	    if(Servidor.length()<5)
	    {
	    Servidor="http://127.0.0.1:8988/miemp-MyWebConferenceServer-context-root";
	    }    
    setSize(250,190);
    setResizable(false);
    final JPanel jpAgruparSesion=new JPanel(null);
    jpAgruparSesion.setBorder(BorderFactory.createTitledBorder("Session"));
    JLabel jlSesionId=new JLabel("Session Id.",2);
    jlSesionId.setBounds(10,30,100,20);
    jpAgruparSesion.add(jlSesionId);    
    final JTextField jtSesionId=new JTextField("",12);
    jtSesionId.setBounds(115,30,100,20);    
    jpAgruparSesion.add(jtSesionId);

    JLabel jlFijar=new JLabel("Remember Id.",2);
    jlFijar.setBounds(10,50,100,20);
    jpAgruparSesion.add(jlFijar);    
    final JCheckBox jcbFijar=new JCheckBox();
    jcbFijar.setBounds(111,50,100,20);    
    jpAgruparSesion.add(jcbFijar);

  
    JButton jbAceptar=new JButton("Login");
    jbAceptar.setBounds(10,70,100,20);
    jpAgruparSesion.add(jbAceptar);    
    JButton jbLimpiar=new JButton("Reset");
    jbLimpiar.setBounds(111,70,100,20);
    jbLimpiar.addActionListener(new ActionListener()
    {
	public void actionPerformed(ActionEvent evt)
	{
	  jtSesionId.setText("");
	  jcbFijar.setSelected(false);
	}
    });
    jpAgruparSesion.add(jbLimpiar);
    jpAgruparSesion.setBounds(10,5,225,140);
    getContentPane().setLayout(null);
    getContentPane().add(jpAgruparSesion);
    
    final JPanel jpAgruparOpciones=new JPanel(null);
    jpAgruparOpciones.setBorder(BorderFactory.createTitledBorder("Options"));
     final JToggleButton jbView=new JToggleButton("Send screen capture");
    jbView.setBounds(10,30,205,20);
    jpAgruparOpciones.add(jbView);
    final JToggleButton jbMouse=new JToggleButton("Share mouse");
    jbMouse.setEnabled(false);
    jbMouse.setBounds(10,55,205,20);    
    jpAgruparOpciones.add(jbMouse);
    final JToggleButton jbKeyboard=new JToggleButton("Share keyboard");
    jbKeyboard.setEnabled(false);
    jbKeyboard.setBounds(10,80,205,20);     
    jpAgruparOpciones.add(jbKeyboard);
    
    setVisible(true);
    jbAceptar.addActionListener(new ActionListener()
	{
	    public void actionPerformed(ActionEvent evt)
	    {
	      if(jtSesionId.getText().length()>0)
	      {
	        jpAgruparOpciones.setBounds(10,5,225,140);  
    	        getContentPane().add(jpAgruparOpciones);
	        getContentPane().remove(jpAgruparSesion);	
	        jpAgruparOpciones.validate();
	        getContentPane().repaint();
		Id=jtSesionId.getText();
	        start();
	      }
	      else
	      {
		JOptionPane.showMessageDialog(null,"Please insert the session number","Warning",2);
	      }
	    }
	});     
    jbView.addActionListener(new ActionListener()
    {
	public void actionPerformed(ActionEvent evt)
	{
	  if(jbView.isSelected())
	  {
	    capture=true;
	    jbMouse.setEnabled(true);
	    jbKeyboard.setEnabled(true);
	  }
	  else
	  {
	    capture=false;
	    jbMouse.setEnabled(false);
	    jbKeyboard.setEnabled(false);	    
	  }
	}
    }
    );

    setDefaultCloseOperation(3);
  }

  public void start()
  {
    if(Hilo==null)
    {
      Hilo=new Thread(this);
    }
    Hilo.start();
  }

  public void run()
  {
    while(true)
    {
      DataInputStream entrada=null;
      DataOutputStream salida=null;
      try
      {
	if((capture)&&(Id!=null))
	{
	URL url=new URL(Servidor+"/inicio.do?id="+Id);	
    	URLConnection urlc=url.openConnection();
	urlc.setAllowUserInteraction(true);
	urlc.setDoOutput(true);
	urlc.setDoInput(true);
	salida=new DataOutputStream(urlc.getOutputStream());
	if(screencapture!=null)
	{
	  screencapture.flush();
	}
	screencapture=new Robot().createScreenCapture(new Rectangle(Toolkit.getDefaultToolkit().getScreenSize()));


	  byte[] pngbytes=null;
	  int filter=0;
	  int compressionLevel=9;
	  PngEncoderB png =  new PngEncoderB(screencapture,PngEncoder.NO_ALPHA,filter, compressionLevel);
      pngbytes = png.pngEncode();
      salida.write( pngbytes );

	//ImageIO.write(screencapture,"PNG",salida);
	entrada=new DataInputStream(urlc.getInputStream());	
	//System.out.println("Capturando");
	salida.close();
	entrada.close();
	}
	Hilo.sleep(5000);
      }
      catch(InterruptedException e)
      {
	System.out.println("aqui 1:"+e.toString());
      }
      catch(ConnectException e)
      {
	System.out.println("aqui 2:"+e.toString());      
      }
      catch(Exception e)
      {
	try
	{
	  Hilo.sleep(5000);
	}
	catch(InterruptedException ex)
	{
	  System.out.println("aqui 4:"+ex.toString());
	}
      }
      if(!this.isVisible())
      {
	System.exit(0);
      }
    }
  }

  public static void main(String[] args)
    throws AWTException,IOException
  {
    new ScreenCapture();
  }
}
